#!/usr/bin/env ruby
# -*- coding: utf-8 -*-

$: << File.dirname(__FILE__)

require "twbot2"
require "rexml/document"

class SimpleBot < TwBot
  def load_data
    # =============================================================
    # What the bot talks should be defined in 'load_data' method.
    # This example is to fetch mentions to the bot and notify them.
    # =============================================================
    
    # ---------- fetch replies ----------
    
    # downloading the XML
    response = auth_http.get("/1/statuses/mentions.xml")
    xml = REXML::Document.new(response.body)
    
    # extracting only message IDs of the XML
    mentions_ids = xml.elements.to_a("/statuses/status/id")
    mentions_ids.map!{ |x| x.text.to_i }
    
    # ---------- exclude old replies ----------
    
    # If you create a new key in the Hash @config,
    # this will be kept in the config file.
    @config['last_id'] ||= 0
    
    # keeping the newest ID among the downloaded mentions
    new_last_id = mentions_ids.first
    
    # excluding the IDs representing old messages
    mentions_ids.reject!{ |m_id| m_id < @config['last_id'] }
    
    # renewing the newest ID
    @config['last_id'] = new_last_id
    
    # ---------- return the message to be posted ----------
    
    # The return value must be an array.
    # If you specify strings as the return value,
    # the bot will talk it as it is,
    # when you run 'ruby simplebot.rb post'.
    
    ["#{mentions_ids.size} new replies found!"]
  end
end

self_path = File.dirname(__FILE__)
ARGV.each do |mode|
  SimpleBot.new mode, "#{self_path}/config.yml", "#{self_path}/error.log"
end
